﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Windows.Forms;


namespace CAN_2055C_demo
{
    public partial class Form1 : Form
    {
    	//Global Variable
        Graphics g;
        Byte VxCAN_port;
        Bitmap img = new Bitmap(535, 41);
        int DO_data = 0;

		public Form1()
        {
            InitializeComponent();
        }

        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];
                        
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            } 
        }

        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;
            Byte COMPortListCount = 0, BaudRateListCount, DataBitsListCount, StopBitsListCount, ParityListCount, CheckSumListCount;
            Byte[] COMPortList = new Byte[255];
            UInt32[] BaudRateList, DataBitsList, StopBitsList, ParityList, CheckSumList;

            //The VxCAN_SearchCANModule() will search with 2400~921600bps and 5~8 data-bits.
            //It will cost almost 5~10 minutes.
            //ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();

            //===================================================================//
            //The user can use VxCAN_SearchCANModuleExAll() instead.
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_GetCurrentCOMPorts(ref COMPortListCount, COMPortList);
            BaudRateList = new UInt32[]{921600, 115200};
            DataBitsList = new UInt32[]{8}; //8 data-bit
   	        StopBitsList = new UInt32[]{1}; //1 stop-bit
	        ParityList = new UInt32[]{0}; //0: None parity
	        CheckSumList = new UInt32[]{0, 1}; //0: Disable Checksum, 1:Enable Checksum
            BaudRateListCount = (Byte)BaudRateList.Count();
            DataBitsListCount = (Byte)DataBitsList.Count();
            StopBitsListCount = (Byte)StopBitsList.Count();
            ParityListCount = (Byte)ParityList.Count();
            CheckSumListCount = (Byte)CheckSumList.Count();
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModuleExAll(
                                            COMPortListCount, COMPortList, 
                                            BaudRateListCount, BaudRateList, 
                                            DataBitsListCount, DataBitsList, 
                                            StopBitsListCount, StopBitsList, 
                                            ParityListCount, ParityList, 
                                            CheckSumListCount, CheckSumList);
            //===================================================================//
            

            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);                  
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort=0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");

 

            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0',50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];

                    //2055C is not a UART module so its VxCAN_COMPortBaudRate = 0xFFFFFFFF
                    //we use -1 to represent that
                    if (_VxCAN_COMPortBaudRate[i] == 0xFFFFFFFF)                                                        
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = -1;                 
                    else
                        dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }            
            }
        }
         

        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            g = Graphics.FromImage(img);
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
            for (int i = 0; i < 8; i++)
            {
                drawLed(40 + 60 * i, 5, false);
            }
     
        }

        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(0);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(0);

        }


        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID =(Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            //clear dataGridView2
            dataGridView2.Columns.Clear();
            dataGridView2.Rows.Clear();

            
            //digital input
            if (rd2.Checked)
            {
                //Clean buffer for Latest Data
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

                //Set 1 second interval of event timer 
                ID = 0x600 + NumID;
                Len = 0x8;
                Data[0] = 0x2B;
                Data[1] = 0x00;
                Data[2] = 0x18;
                Data[3] = 0x05;
                Data[4] = 0xE8;
                Data[5] = 0x03;
                Data[6] = 0x00;
                Data[7] = 0x00;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

                dataGridView2.Columns.Add("ID", "ID");
                dataGridView2.Columns.Add("Mode", "Mode");
                dataGridView2.Columns.Add("RTR", "RTR");
                dataGridView2.Columns.Add("Len", "Len");
                dataGridView2.Columns.Add("DI0", "DI0");
                dataGridView2.Columns.Add("DI1", "DI1");
                dataGridView2.Columns.Add("DI2", "DI2");
                dataGridView2.Columns.Add("DI3", "DI3");
                dataGridView2.Columns.Add("DI4", "DI4");
                dataGridView2.Columns.Add("DI5", "DI5");
                dataGridView2.Columns.Add("DI6", "DI6");
                dataGridView2.Columns.Add("DI7", "DI7");
                dataGridView2.Columns.Add("MsgTimeStamps", "MsgTimeStamps");

                dataGridView2.Columns["ID"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["Mode"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["RTR"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["Len"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI0"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI1"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI2"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI3"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI4"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI5"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI6"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;
                dataGridView2.Columns["DI7"].AutoSizeMode = DataGridViewAutoSizeColumnMode.DisplayedCells;

                //Start Timer2
                timer2.Enabled = true;
 
            }
            // Operation State is checked.
            if (rd1.Checked)
            {
                ID = 0x000;
                Len = 0x2;
                Data[0] = 0x01;
                Data[1] = DataID;
                VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data); 
				MessageBox.Show("CAN2055C is in operation mode!");
            }
          
        }
        private void drawLed(int x, int y, bool a)
        {
            System.Drawing.SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.White);
            if(a)
                drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.GreenYellow);
            else
                drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Gray);

            g.FillEllipse(drawBrush, x,y, 20,20);
            pictureBox1.Refresh();

        }

        private void timer2_Tick(object sender, EventArgs e)
        {
            //Initialize parameters
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            byte Mode = 0, RTR = 0, Len = 0;
            byte[] Data = new Byte[8];
            ushort RxCnt = 0;
            UInt32 ret = 0, ID = 0;
            Double MsgTimeStamps = 0;
            UInt32 TimeOut = 0;
            int[] bit = new int[8];


            while (true && TimeOut++ < 20000)
            {
                //get the amount of CAN message in Virtual CAN buffer
                ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_RxMsgCount(VxCAN_port, ref RxCnt);
                int currentRowIndexInt;
                if (ret == 0)
                {
                    if (RxCnt > 0)
                    {
                        //output all CAN message in Virtual CAN buffer
                        for (int i = 0; i < RxCnt; i++)
                        {
                            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCAN_port, ref ID, ref Mode, ref RTR, ref Len, Data, ref MsgTimeStamps);
                            if (ret == 0)
                            {
                                if (ID == (0x180 + NumID))
                                {

                                    for (int j = 0; j < 8;j++ )
                                        bit[j] = (Data[0] & (1<<j))>>j;

                                    dataGridView2.Rows.Add();
                                    dataGridView2["ID", dataGridView2.Rows.Count - 1].Value = ID.ToString("X3");
                                    dataGridView2["Mode", dataGridView2.Rows.Count - 1].Value = Mode.ToString("X1");
                                    dataGridView2["RTR", dataGridView2.Rows.Count - 1].Value = RTR.ToString("X1");
                                    dataGridView2["Len", dataGridView2.Rows.Count - 1].Value = Len.ToString("X1");
                                    dataGridView2["DI0", dataGridView2.Rows.Count - 1].Value = bit[0].ToString();
                                    dataGridView2["DI1", dataGridView2.Rows.Count - 1].Value = bit[1].ToString();
                                    dataGridView2["DI2", dataGridView2.Rows.Count - 1].Value = bit[2].ToString();
                                    dataGridView2["DI3", dataGridView2.Rows.Count - 1].Value = bit[3].ToString();
                                    dataGridView2["DI4", dataGridView2.Rows.Count - 1].Value = bit[4].ToString();
                                    dataGridView2["DI5", dataGridView2.Rows.Count - 1].Value = bit[5].ToString();
                                    dataGridView2["DI6", dataGridView2.Rows.Count - 1].Value = bit[6].ToString();
                                    dataGridView2["DI7", dataGridView2.Rows.Count - 1].Value = bit[7].ToString();
                                    dataGridView2["MsgTimeStamps", dataGridView2.Rows.Count - 1].Value = MsgTimeStamps.ToString();

                                    currentRowIndexInt = dataGridView2.Rows.Count - 1;
                                    dataGridView2.CurrentCell = dataGridView2[0, currentRowIndexInt];

                                }
                            }
                        }
                        break;
                    }
                }
            }

        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(0);
            if(ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(0, ref ModuleStatus, ref CANChipStatus);
            if(ret == 0)
            {
                MessageBox.Show("Module Status = "+ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private void Btn_SendStopMsg_Click(object sender, EventArgs e)
        {
			UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ret = 0, ID = 0x000;
            Byte[] Data = new Byte[8];
						

            //Set 0 second interval of event timer to disable event timer
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2B;
            Data[1] = 0x00;
            Data[2] = 0x18;
            Data[3] = 0x05;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            if (ret != 0)
            {
                MessageBox.Show("Close Event Timer Fail!!");
            }

            //Stop timer
            timer2.Enabled = false;
        }
        //turn on or off the DO0 channel
        private void btn_DO0_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];
            
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO0.Text == "on")
            {
                DO_data |= 0x01;
                drawLed(40 , 5, true);
                btn_DO0.Text = "off";
            }
            else
            {
                DO_data &= 0xFE;
                drawLed(40 , 5, false);
                btn_DO0.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

        }

        //turn on or off the DO1 channel
        private void btn_DO1_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO1.Text == "on")
            {
                DO_data |= 0x02;
                drawLed(40 + 60 * 1, 5, true);
                btn_DO1.Text = "off";
            }
            else
            {
                DO_data &= 0xFD;
                drawLed(40 + 60 * 1, 5, false);
                btn_DO1.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO2 channel
        private void btn_DO2_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO2.Text == "on")
            {
                DO_data |= 0x04;
                drawLed(40 + 60 * 2, 5, true);
                btn_DO2.Text = "off";
            }
            else
            {
                DO_data &= 0xFB;
                drawLed(40 + 60 * 2, 5, false);
                btn_DO2.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO3 channel
        private void btn_DO3_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);


            byte bit;
            if (btn_DO3.Text == "on")
            {
                DO_data |= 0x08;
                drawLed(40 + 60 * 3, 5, true);
                btn_DO3.Text = "off";
            }
            else
            {
                DO_data &= 0xF7;
                drawLed(40 + 60 * 3, 5, false);
                btn_DO3.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO4 channel
        private void btn_DO4_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO4.Text == "on")
            {
                DO_data |= 0x10;
                drawLed(40 + 60 * 4, 5, true);
                btn_DO4.Text = "off";
            }
            else
            {
                DO_data &= 0xEF;
                drawLed(40 + 60 * 4, 5, false);
                btn_DO4.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO5 channel
        private void btn_DO5_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO5.Text == "on")
            {
                DO_data |= 0x20;
                drawLed(40 + 60 * 5, 5, true);
                btn_DO5.Text = "off";
            }
            else
            {
                DO_data &= 0xDF;
                drawLed(40 + 60 * 5, 5, false);
                btn_DO5.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO6 channel
        private void btn_DO6_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO6.Text == "on")
            {
                DO_data |= 0x40;
                drawLed(40 + 60 * 6, 5, true);
                btn_DO6.Text = "off";
            }
            else
            {
                DO_data &= 0xBF;
                drawLed(40 + 60 * 6, 5, false);
                btn_DO6.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //turn on or off the DO7 channel
        private void btn_DO7_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);

            byte bit;
            if (btn_DO7.Text == "on")
            {
                DO_data |= 0x80;
                drawLed(40 + 60 * 7, 5, true);
                btn_DO7.Text = "off";
            }
            else
            {
                DO_data &= 0x7F;
                drawLed(40 + 60 * 7, 5, false);
                btn_DO7.Text = "on";
            }

            bit = (byte)DO_data;


            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = bit;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }
        //when close Form1,clear all DO channels
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCANPort);
            ID = 0x600 + NumID;
            Len = 0x8;
            Data[0] = 0x2F;
            Data[1] = 0x00;
            Data[2] = 0x62;
            Data[3] = 0x01;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            pictureBox1.Image = img;
        }

       
    }
}
